<?php
/************************************************************************
 This file is part of Desk-Weather.
 Desk-Weather is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 Desk-Weather is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with Desk-Weather.  If not, see <http://www.gnu.org/licenses/>.
 *************************************************************************/

$city = $_POST['city'];

$soap = 'http://xoap.weather.com/weather/local/'.$city.'?cc=*&dayf=5';
$content = file_get_contents($soap);

function f2c($t) { return round(($t-32)*5/9); }
function miles2kilometres($o) { return round($o*1.609344);}
function inHg2mb($o) { return round($o*33.86, 1); }
function convert_date($date) {return strtotime(substr($date, 0, strlen($date) -11));}

$xml = new SimpleXMLElement($content);

$data = '';

function get_info_day($num) {
global $xml, $data, $Libel_day;

 $item = $xml->dayf->day[$num];

 $day = $item->part[0];
 $night = $item->part[1];

 foreach( $item->Attributes() as $k=>$v ) {

  if( $k == 't' ) {

   $data[$num]['day']['origin'] = "{$v}";

  }

 }

$data[$num]['icon'] = (strlen($day->icon) == 1 ) ? "0{$day->icon}" : "{$day->icon}";
$data[$num]['ppcp'] = "{$day->ppcp}%";
$data[$num]['humidity'] = "{$day->hmid}%";

$data[$num]['tmp']['hi']['metric'] = ($item->hi == 'N/A' ) ? 'N/A' : f2c($item->hi).'&deg;C';
$data[$num]['tmp']['hi']['english'] = ($item->hi == 'N/A' ) ? 'N/A' : "{$item->hi}&deg;F";

$data[$num]['tmp']['low']['metric'] = ($item->low == 'N/A' ) ? 'N/A' : f2c($item->low).'&deg;C';
$data[$num]['tmp']['low']['english'] = ($item->low == 'N/A' ) ? 'N/A' : "{$item->low}&deg;F";


}

//$data['lastupdate_beautiful'] = 'Aujourd\'hui - '.beautiful_date(convert_date($xml->dayf->lsup));

$data['lastupdate']['readable'] = convert_date($xml->cc->lsup);
$data['lastupdate']['num_day'] = date("N", convert_date($xml->cc->lsup));
$data['lastupdate']['num_month'] = date("n", convert_date($xml->cc->lsup));

$data['lastupdate']['d'] = date("d", convert_date($xml->cc->lsup));
$data['lastupdate']['hour'] = date("H:i", convert_date($xml->cc->lsup));
$data['lastupdate']['y'] = date("Y", convert_date($xml->cc->lsup));

$data['lastupdate']['origin'] = "{$xml->cc->lsup}";

$data['cc']['icon'] = ( strlen($xml->cc->icon) == 1 )? "0{$xml->cc->icon}" : "{$xml->cc->icon}";
$data['cc']['night_icon'] = ( strlen($xml->cc->moon->icon) == 1 )? "0{$xml->cc->moon->icon}":"{$xml->cc->moon->icon}";

$data['cc']['tmp_night']['metric'] = ($xml->dayf->day[0]->low == 'N/A' ) ? 'N/A' : f2c($xml->dayf->day[0]->low).'&deg;C';
$data['cc']['tmp_night']['english'] = ($xml->dayf->day[0]->low == 'N/A' ) ? 'N/A' : "{$xml->dayf->day[0]->low}&deg;F";

$data['cc']['tmp']['metric'] = ($xml->cc->tmp == 'N/A' ) ? 'N/A' : f2c($xml->cc->tmp).'&deg;C';
$data['cc']['tmp']['english'] = ($xml->cc->tmp == 'N/A' ) ? 'N/A' : "{$xml->cc->tmp}&deg;F";

$data['cc']['tmp_ressenti']['metric'] = ($xml->cc->flik == 'N/A' ) ? 'N/A' : f2c($xml->cc->flik).'&deg;C';
$data['cc']['tmp_ressenti']['english'] = ($xml->cc->flik == 'N/A' ) ? 'N/A' : "{$xml->cc->flik}&deg;F";

$data['cc']['dewp']['metric'] = ($xml->cc->dewp == 'N/A' ) ? 'N/A' : f2c($xml->cc->dewp).'&deg;C';
$data['cc']['dewp']['english'] = ($xml->cc->dewp == 'N/A' ) ? 'N/A' : "{$xml->cc->dewp}&deg;F";

$data['cc']['humidity'] = "{$xml->cc->hmid}%";

$data['cc']['visibility']['metric'] = ($xml->cc->vis == 'N/A' ) ? 'N/A' : miles2kilometres($xml->cc->vis).' km';
$data['cc']['visibility']['english'] = ($xml->cc->vis == 'N/A' ) ? 'N/A' : "{$xml->cc->vis} miles";

$data['cc']['bar']['metric'] = ($xml->cc->bar->r == 'N/A' ) ? 'N/A' : inHg2mb($xml->cc->bar->r).' mb';
$data['cc']['bar']['english'] = ($xml->cc->bar->r == 'N/A' ) ? 'N/A' : "{$xml->cc->bar->r} inHg";

$data['cc']['uv_value'] = ($xml->cc->uv->i == 'N/A' ) ? 'N/A' : "{$xml->cc->uv->i}";
$data['cc']['uv_libel'] = ($xml->cc->uv->t == 'N/A' ) ? 'N/A' : "{$xml->cc->uv->t}";


$data['cc']['wind_speed']['metric'] = ($xml->cc->wind->s == 'N/A' ) ? 'N/A' : miles2kilometres($xml->cc->wind->s)." km/h";
$data['cc']['wind_speed']['english'] = ($xml->cc->wind->s == 'N/A' ) ? 'N/A' : "{$xml->cc->wind->s} mph";

$data['cc']['wind_direction'] = "{$xml->cc->wind->t}";

// day 1
get_info_day(1);
get_info_day(2);
get_info_day(3);
get_info_day(4);
/*
echo '<pre>';
print_r($data);
echo '</pre><hr><pre>';
print_r($xml);
echo '</pre>';
*/

echo '{"success":true, "data" : '.json_encode($data).'}';
?>